unit UFormConsole;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  UMachine, UCpu;

type

  { TFormConsole }

  TFormConsole = class(TForm)
    MemoConsole: TMemo;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MemoConsoleKeyPress(Sender: TObject; var Key: char);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    Console: TConsole;
  end;

var
  FormConsole: TFormConsole;

implementation

{$R *.lfm}

{ TFormConsole }

procedure TFormConsole.Timer1Timer(Sender: TObject);
var
  Buffer: string;
  C: TInteger;
begin
  Console.Lock.Acquire;
  try
    SetLength(Buffer, 0);
    while Console.OutputBuffer.Count > 0 do begin
      SetLength(Buffer, Length(Buffer) + 1);
      C := Console.OutputBuffer.Dequeue;
      //if C >= 32 then
      Buffer[Length(Buffer)] := Chr(C);
    end;
    MemoConsole.Text := MemoConsole.Text + Buffer;
  finally
    Console.Lock.Release;
  end;
end;

procedure TFormConsole.MemoConsoleKeyPress(Sender: TObject; var Key: char);
begin
  Console.Lock.Acquire;
  try
    Console.InputBuffer.Enqueue(Byte(Key));
  finally
    Console.Lock.Release;
  end;
  Console.Cpu.Interrupt(Console.InterruptVector);
end;

procedure TFormConsole.FormShow(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TFormConsole.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
begin
  Timer1.Enabled := False;
end;

end.

